Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_analog.c
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_analog.c	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_analog.c	(revision 224)
@@ -31,16 +31,9 @@
 static int DAC_RESOLUTION = 10;
 
-// Wait for synchronization of registers between the clock domains
-static __inline__ void syncDAC() __attribute__((always_inline, unused));
-static void syncDAC() {
-  while (DAC->STATUS.bit.SYNCBUSY == 1)
-    ;
-}
-
 void analogReadResolution(int res) {
 	_readResolution = res;
 	while( ADC->STATUS.bit.SYNCBUSY == 1 )
   {
-    // Waiting for synchroinization
+    // Waiting for synchronization
   }
 	if(res == 8) ADC->CTRLB.bit.RESSEL= ADC_CTRLB_RESSEL_8BIT_Val; 
@@ -69,5 +62,5 @@
   while( ADC->STATUS.bit.SYNCBUSY == 1 )
   {
-    // Waiting for synchroinization
+    // Waiting for synchronization
   }
   switch(ulMode)
@@ -91,5 +84,5 @@
   while( ADC->STATUS.bit.SYNCBUSY == 1 )
   {
-    // Waiting for synchroinization
+    // Waiting for synchronization
   }
 }
@@ -154,5 +147,5 @@
     	DAC->DATA.reg = ulValue & 0x3FF;  // Dac on 10 bits.
 		DAC->CTRLA.bit.ENABLE = 1; // DAC Enabled
-		syncDAC();
+		while (DAC->STATUS.bit.SYNCBUSY == 1); //wait for synchronization
       	return;
     }
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_digital.c
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_digital.c	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/cores/arduino/wiring_digital.c	(revision 224)
@@ -178,4 +178,5 @@
 
     default:
+	  PORT->Group[g_APinDescription[ulPin].ulPort].OUTSET.reg = (1ul << g_APinDescription[ulPin].ulPin) ;
     break ;
   }
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSAndMCUOnOff/TianMIPSAndMCUOnOff.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSAndMCUOnOff/TianMIPSAndMCUOnOff.ino	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSAndMCUOnOff/TianMIPSAndMCUOnOff.ino	(revision 224)
@@ -0,0 +1,50 @@
+/*
+
+This sketch allows the users to manage the Tian and MCU power management.
+Users can power up or power down MIPS and MCU with an external interrupt.
+
+*/
+
+#include <EnergySaving.h>
+
+EnergySaving nrgSave;
+
+#define MIPS_PIN 32  //PA28 PIN 32
+
+void setup()
+{
+  pinMode(MIPS_PIN,OUTPUT);
+  digitalWrite(MIPS_PIN,HIGH);
+
+  nrgSave.begin(WAKE_EXT_INTERRUPT, 8, wakeUp);  //standby setup for external interrupts
+}
+
+void loop()
+{
+  doSomething();
+  sleep();
+}
+
+void doSomething(){
+  //blink for 90 seconds
+  for(int i=0; i<90; i++)
+  {
+    digitalWrite(13,HIGH);
+    delay(500);
+    digitalWrite(13,LOW);
+    delay(500);
+  }
+}
+
+void sleep(void){
+  digitalWrite(MIPS_PIN, LOW);
+  nrgSave.standby();  //now mcu goes in standby mode
+}
+
+void wakeUp(void)  //interrupt routine (isn't necessary to execute any tasks in this routine
+{
+  //mcu is waked-up by the interrupt
+
+  //wake up mips
+  digitalWrite(MIPS_PIN,HIGH);
+}
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSOnOff/TianMIPSOnOff.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSOnOff/TianMIPSOnOff.ino	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/TianMIPSOnOff/TianMIPSOnOff.ino	(revision 224)
@@ -0,0 +1,63 @@
+/*
+
+This sketch allows the users to manage the Tian power management.
+Users can power up or power down the MIPS side from the MCU serial console.
+
+After upload the sketch, open the Serial Terminal and press the send button.
+
+COMMANDS
+----------------------
+h - help
+D - power down MIPS
+U - power up MIPS
+
+created March 2016
+  by andrea@arduino.org
+
+ */
+
+#define MIPS_PIN 32  //PA28 PIN 32
+
+char var;
+
+void setup() {
+  // put your setup code here, to run once:
+  Serial.begin(115200);
+
+  pinMode(MIPS_PIN,OUTPUT);    //MIPS
+  digitalWrite(MIPS_PIN,HIGH);
+  while(!Serial.available());;
+  menu('h');
+}
+
+void loop() {
+  // put your main code here, to run repeatedly:
+  while (Serial.available()){
+    var = Serial.read();
+    menu(var);
+  }
+}
+
+void menu( char var){
+     switch (var) {
+      case 'D':
+        Serial.println("MIPS OFF");
+        Serial.println();
+        digitalWrite(MIPS_PIN,LOW);
+        break;
+      case 'U':
+        Serial.println("MIPS ON");
+        Serial.println();
+        digitalWrite(MIPS_PIN,HIGH);
+        break;
+      case 'h':
+        Serial.println("COMMANDS");
+        Serial.println("----------------------");
+        Serial.println("h - help");
+        Serial.println("D - power down MIPS");
+        Serial.println("U - power up MIPS");
+        Serial.println();
+        break;
+    }
+
+}
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnExternalInterrupt/WakeUpOnExternalInterrupt.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnExternalInterrupt/WakeUpOnExternalInterrupt.ino	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnExternalInterrupt/WakeUpOnExternalInterrupt.ino	(revision 224)
@@ -0,0 +1,36 @@
+/********************************************************************************************
+ This sketch demonstrates how sleep function using external interrupt to wake up the MCU.
+ This sketch work only cortex-m0+ boards.
+*********************************************************************************************/
+
+
+
+#include <EnergySaving.h>
+
+EnergySaving nrgSave;
+
+unsigned int i=0;
+
+void setup()
+{
+  nrgSave.begin(WAKE_EXT_INTERRUPT, 8, dummy);  //standby setup for external interrupts
+}
+
+void loop()
+{
+  for(i=0; i<20; i++)
+  {
+    digitalWrite(13,HIGH);
+    delay(500);
+    digitalWrite(13,LOW);
+    delay(500);
+  }
+
+  nrgSave.standby();  //now mcu goes in standby mode
+}
+
+
+void dummy(void)  //interrupt routine (isn't necessary to execute any tasks in this routine
+{
+
+}
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnRTCInterrupt/WakeUpOnRTCInterrupt.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnRTCInterrupt/WakeUpOnRTCInterrupt.ino	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/examples/WakeUpOnRTCInterrupt/WakeUpOnRTCInterrupt.ino	(revision 224)
@@ -0,0 +1,53 @@
+/***********************************************************************************************
+ This sketch demonstrates how to use sleep features and wake-up MCU with RTC alarm interrupt.
+ This sketch works only on cortex-m0+ based boards.
+************************************************************************************************/
+
+#include <EnergySaving.h>
+#include <RTCInt.h>
+
+EnergySaving nrgSave;
+RTCInt rtc;
+
+unsigned int i=0;
+
+void setup()
+{
+
+  pinMode(30,OUTPUT);  //led RX
+  Serial5.begin(9600);   //serial settings
+  rtc.begin(TIME_H24);
+  rtc.setTime(12,48,0,0);
+  rtc.setDate(22,10,15);
+  rtc.enableAlarm(SEC,ALARM_INTERRUPT,rest_alarm_int);
+  rtc.local_time.hour=12;
+  rtc.local_time.minute=48;
+  rtc.local_time.second=30;
+  nrgSave.begin(WAKE_RTC_ALARM);  //standby setup for external interrupts
+  rtc.setAlarm();
+  SerialUSB.println("START");
+
+}
+
+void loop()
+{
+  for(i=0; i<20; i++)
+  {
+    digitalWrite(13,HIGH);
+    delay(500);
+    digitalWrite(13,LOW);
+    delay(500);
+  }
+
+  digitalWrite(30,LOW);
+  nrgSave.standby();  //now mcu go to standby
+
+}
+
+void rest_alarm_int(void)  //interrupt routine
+{
+  //PORT->Group[1].OUTSET.reg = 0x1u<<3;
+  digitalWrite(30,HIGH);
+
+  Serial5.println("HELLO");
+}
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.cpp	(revision 224)
@@ -0,0 +1,111 @@
+#include "EnergySaving.h"
+
+void EnergySaving::begin(unsigned int mode, unsigned int inter_pin, voidFuncPtr callback)
+{
+	if((mode == WAKE_EXT_INTERRUPT) && (inter_pin !=2) &&  (inter_pin!=0) && (inter_pin!=1))
+	{
+		 NVMCTRL->CTRLB.bit.SLEEPPRM = 3;
+
+		SCB->SCR |= SCB_SCR_SLEEPDEEP_Msk;
+		pinMode(inter_pin,INPUT_PULLUP);
+
+		attachInterrupt(inter_pin,callback, CHANGE);
+		enable_eic_wake(inter_pin);
+		set_clk();
+
+	}
+	else return;
+}
+
+
+void EnergySaving::begin(unsigned int mode)
+{
+	if(mode == WAKE_RTC_ALARM)
+	{
+		//RTCInt.begin(TIME_H24);
+
+		GCLK->CLKCTRL.bit.CLKEN = 0; //disable GCLK module
+		while (GCLK->STATUS.bit.SYNCBUSY);
+
+		GCLK->GENCTRL.bit.RUNSTDBY = 1;  //GCLK6 run standby
+		while (GCLK->STATUS.reg & GCLK_STATUS_SYNCBUSY);
+
+		GCLK->CLKCTRL.bit.CLKEN = 1; //disable GCLK module
+		while (GCLK->STATUS.bit.SYNCBUSY);
+
+		NVMCTRL->CTRLB.bit.SLEEPPRM = 3;
+
+		SCB->SCR |= SCB_SCR_SLEEPDEEP_Msk;
+
+	}
+	else return;
+
+}
+
+
+void EnergySaving::standby(void)
+{
+	__DSB();
+    __WFI();
+
+}
+
+
+void EnergySaving::set_clk(void)
+{
+	GCLK->CLKCTRL.bit.CLKEN = 0; //disable GCLK module
+		while (GCLK->STATUS.bit.SYNCBUSY);
+
+		GCLK->CLKCTRL.reg = (uint16_t) (GCLK_CLKCTRL_CLKEN | GCLK_CLKCTRL_GEN_GCLK6 | GCLK_CLKCTRL_ID( GCM_EIC )) ;  //EIC clock switched on GCLK6
+		while (GCLK->STATUS.bit.SYNCBUSY);
+
+		GCLK->GENCTRL.reg = (GCLK_GENCTRL_GENEN | GCLK_GENCTRL_SRC_OSCULP32K | GCLK_GENCTRL_ID(6));  //source for GCLK6 is OSCULP32K
+		while (GCLK->STATUS.reg & GCLK_STATUS_SYNCBUSY);
+
+		GCLK->GENCTRL.bit.RUNSTDBY = 1;  //GCLK6 run standby
+		while (GCLK->STATUS.reg & GCLK_STATUS_SYNCBUSY);
+
+}
+
+
+void EnergySaving::enable_eic_wake(unsigned int inter_pin)
+{
+	switch(inter_pin)
+		{
+			case 3:
+				EIC->WAKEUP.bit.WAKEUPEN9 = 1;
+				break;
+			case 4:
+				EIC->WAKEUP.bit.WAKEUPEN14 = 1;
+				break;
+			case 5:
+				EIC->WAKEUP.bit.WAKEUPEN15 = 1;
+				break;
+			case 6:
+				//EIC->WAKEUP.bit.WAKEUPEN20 = 1;  //non si pu嘆 usare
+				break;
+			case 7:
+				//EIC->WAKEUP.bit.WAKEUPEN21 = 1;  //non si pu嘆 usare
+				break;
+			case 8:
+				EIC->WAKEUP.bit.WAKEUPEN6 = 1;
+				break;
+			case 9:
+				EIC->WAKEUP.bit.WAKEUPEN7 = 1;
+				break;
+			case 10:
+				//EIC->WAKEUP.bit.WAKEUPEN18 = 1;  //non si pu嘆 usare
+				break;
+			case 11:
+				//EIC->WAKEUP.bit.WAKEUPEN16 = 1;  //non c'竪
+				break;
+			case 12:
+				//EIC->WAKEUP.bit.WAKEUPEN19 = 1;  //non si pu嘆 usare
+				break;
+			case 13:
+				//EIC->WAKEUP.bit.WAKEUPEN17 = 1;  //non c'竪
+				break;
+			default:
+				break;
+		}
+}
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/EnergySaving/src/EnergySaving.h	(revision 224)
@@ -0,0 +1,26 @@
+#ifndef energy_saving_h
+#define energy_saving_h
+
+
+#include <sam.h>
+#include <Arduino.h>
+
+#define WAKE_EXT_INTERRUPT 1
+#define WAKE_RTC_ALARM 2
+
+typedef void (*voidFuncPtr)( void ) ;
+
+class EnergySaving {
+	public:
+		//sleep();
+		void begin(unsigned int mode, unsigned int inter_pin, voidFuncPtr callback);
+		void begin(unsigned int mode);
+		void standby(void);
+
+	private:
+		void set_clk(void);
+		void enable_eic_wake(unsigned int inter_pin);
+
+};
+
+#endif
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.cpp	(revision 224)
@@ -13,4 +13,5 @@
 #include "assert.h"
 #include "variant.h"
+#include <Arduino.h>
 
 SPIClass::SPIClass(SERCOM *p_sercom, uint8_t uc_pinMISO, uint8_t uc_pinSCK, uint8_t uc_pinMOSI)
@@ -38,8 +39,61 @@
 }
 
+
+void SPIClass::beginSlave()
+{
+  // PIO init
+  pinPeripheral(_uc_pinMiso, g_APinDescription[_uc_pinMiso].ulPinType);
+  pinPeripheral(_uc_pinSCK, g_APinDescription[_uc_pinSCK].ulPinType);
+  pinPeripheral(_uc_pinMosi, g_APinDescription[_uc_pinMosi].ulPinType);
+
+	// Default speed set to 4Mhz, SPI mode set to MODE 0 and Bit order set to MSB first.
+	_p_sercom->initSPIslave(SPI_PAD_2_SCK_3, SERCOM_RX_PAD_0, SPI_CHAR_SIZE_8_BITS, MSB_FIRST);
+	
+	_p_sercom->enableSPI();
+}
+
 void SPIClass::end()
 {
 	_p_sercom->resetSPI();
 }
+
+
+void SPIClass::beginTransaction(SPISettings settings)
+	{
+		SercomDataOrder bitOrder;
+		SercomSpiClockMode SpiClockMode;
+		
+		interruptSave = intStatus();
+		noInterrupts();
+		
+	
+		if(settings.bit_order==LSBFIRST) bitOrder = LSB_FIRST;
+		else if(settings.bit_order==MSBFIRST) bitOrder = MSB_FIRST;
+		else;
+		
+		if(settings.data_mode==SPI_MODE0) SpiClockMode = SERCOM_SPI_MODE_0;
+		else if(settings.data_mode==SPI_MODE1) SpiClockMode = SERCOM_SPI_MODE_1;
+		else if(settings.data_mode==SPI_MODE2) SpiClockMode = SERCOM_SPI_MODE_2;
+		else if(settings.data_mode==SPI_MODE3) SpiClockMode = SERCOM_SPI_MODE_3;
+		else;
+		
+		end();
+		
+		pinPeripheral(_uc_pinMiso, g_APinDescription[_uc_pinMiso].ulPinType);
+		pinPeripheral(_uc_pinSCK, g_APinDescription[_uc_pinSCK].ulPinType);
+		pinPeripheral(_uc_pinMosi, g_APinDescription[_uc_pinMosi].ulPinType);
+		
+		_p_sercom->initSPI(SPI_PAD_2_SCK_3, SERCOM_RX_PAD_0, SPI_CHAR_SIZE_8_BITS, bitOrder);
+		_p_sercom->initSPIClock(SpiClockMode, settings.interface_clock);
+	
+	_p_sercom->enableSPI();
+	inTransactionFlag=1;
+	}
+	
+void SPIClass::endTransaction(void)
+{
+	inTransactionFlag=0;
+	interrupts();
+}	
 
 void SPIClass::setBitOrder(BitOrder order)
@@ -76,5 +130,5 @@
 }
 
-void SPIClass::setClockDivider(uint8_t div)
+void SPIClass::setClockDivider(uint16_t div)
 {
 	_p_sercom->setBaudrateSPI(div);
@@ -90,4 +144,104 @@
 }
 
+byte SPIClass::read()
+{
+	return _p_sercom->readDataSPI();
+}
+
+void SPIClass::usingInterrupt(uint8_t intNum)
+{
+	uint8_t irestore;
+	uint32_t mask;
+	
+	irestore=intStatus();
+	noInterrupts();
+	if(intNum > 13)
+	{
+		//Interrupts();
+		return;
+	}
+	else
+	{
+		//Pio *pio=g_APinDescription[intNum].ulPort;
+		mask=g_APinDescription[intNum].ulPin;
+		interruptMode=1;
+		interruptMask=mask;
+	}
+	if (irestore) interrupts();		
+}
+
+void SPIClass::write(uint8_t data)
+{
+	//Writing the data
+	_p_sercom->writeDataSPI(data);
+}
+
+void SPIClass::transfer(void *data, size_t count)
+{
+	uint8_t *p;
+	//int i=0;
+		//Serial.println("dentro transfer");
+	if(count==0) return;
+	p=(uint8_t *)data;
+	_p_sercom->writeDataSPI(*p);  //scrittura primo dato
+	
+	while(--count > 0)
+	{
+		//Serial.println("dentro while");
+		uint8_t out=*(p+1); //copio in out il prossimo dato
+		uint8_t in = _p_sercom->readDataSPI();  //leggo dato da SPI
+		//Serial.println("UNO");
+		//while(!(SERCOM4->SPI.INTFLAG.bit.RXC));  // controllo trasferimento  //vedere se necessario
+		//Serial.println("DUE");
+		//Serial.println(out);
+		_p_sercom->writeDataSPI(out);   //scrivo il out su SPI
+		*p++=in; //metto in p il dato letto da spi
+	}
+	while(!(SERCOM4->SPI.INTFLAG.bit.TXC));  // controllo trasferimrnto
+	//Serial.print("*p: ");
+	//Serial.println(*p);
+	*p = _p_sercom->readDataSPI();
+	
+	
+		
+}
+
+uint16_t SPIClass::transfer16(uint16_t data)
+{
+	union{
+		uint16_t value;
+		struct{
+			uint8_t lsb;
+			uint8_t msb;
+		};
+	}in, out;
+	
+	in.value = data;
+	
+	if(SERCOM4->SPI.CTRLA.bit.DORD==0)
+	{
+		_p_sercom->writeDataSPI(in.msb);
+		while(!(SERCOM4->SPI.INTFLAG.bit.TXC));
+		out.msb = _p_sercom->readDataSPI();
+		//while(!(SERCOM4->SPI.INTFLAG.bit.RXC)); 
+		_p_sercom->writeDataSPI(in.lsb);
+		while(!(SERCOM4->SPI.INTFLAG.bit.TXC));
+		out.lsb = _p_sercom->readDataSPI();
+	}
+
+	else
+	{
+		_p_sercom->writeDataSPI(in.lsb);
+		while(!(SERCOM4->SPI.INTFLAG.bit.TXC));
+		out.lsb = _p_sercom->readDataSPI();
+		//while(!(SERCOM4->SPI.INTFLAG.bit.RXC)); 
+		_p_sercom->writeDataSPI(in.msb);
+		while(!(SERCOM4->SPI.INTFLAG.bit.TXC));
+		out.msb = _p_sercom->readDataSPI();
+	}
+
+		return out.value;
+}
+
 void SPIClass::attachInterrupt() {
 	// Should be enableInterrupt()
Index: rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/hardware/arduino/samd/libraries/SPI/SPI.h	(revision 224)
@@ -14,4 +14,8 @@
 #include "variant.h"
 #include "wiring_constants.h"
+#include <Arduino.h>
+ 
+//#define LSBFIRST 0 //already defined in wiring_constants.h
+//#define MSBFIRST 1 
 
 #define SPI_MODE0 0x02
@@ -20,4 +24,64 @@
 #define SPI_MODE3 0x01
 
+
+#define SPI_CLOCK_DIV2 6       //8 MHz
+#define SPI_CLOCK_DIV4 12      //4 MHz
+#define SPI_CLOCK_DIV8 24      //2 MHz
+#define SPI_CLOCK_DIV16 48     //1 MHz
+#define SPI_CLOCK_DIV32 96     //500 KHz
+#define SPI_CLOCK_DIV64 192    //250 KHz
+#define SPI_CLOCK_DIV128 384   //125 KHz
+
+#ifndef intStatus
+#define intStatus() __intStatus()
+static inline unsigned char __intStatus(void) __attribute__((always_inline, unused));
+static inline unsigned char __intStatus(void) {
+	unsigned int primask, faultmask;
+	asm volatile ("mrs %0, primask" : "=r" (primask));
+	if (primask) return 0;
+	asm volatile ("mrs %0, faultmask" : "=r" (faultmask));
+	if (faultmask) return 0;
+	return 1;
+}
+#endif
+
+class SPISettings {
+	public:
+		SPISettings(uint32_t clock, uint8_t bitOrder, uint8_t dataMode)
+		{
+			interface_clock = clock;
+			bit_order = bitOrder;
+			data_mode = dataMode;
+			
+			/*Serial.print("clock: ");
+			Serial.println(interface_clock);
+			Serial.print("bit order: ");
+			Serial.println(bit_order);
+			Serial.print("data mode: ");
+			Serial.println(data_mode);*/
+		}
+		
+		SPISettings(void)
+		{
+			interface_clock = 4000000;
+			bit_order = MSBFIRST;
+			data_mode = SPI_MODE0;
+			
+			/*Serial.print("clock: ");
+			Serial.println(interface_clock);
+			Serial.print("bit order: ");
+			Serial.println(bit_order);
+			Serial.print("data mode: ");
+			Serial.println(data_mode);*/
+		}
+	private:
+		uint32_t interface_clock;
+		uint8_t bit_order;
+		uint8_t data_mode;
+	
+	friend class SPIClass;	
+};
+
+
 class SPIClass {
   public:
@@ -25,15 +89,24 @@
 
 	byte transfer(uint8_t data);
-
+	void transfer(void *data, size_t count);
+	byte read(void);
+	uint16_t transfer16(uint16_t data);
+	void write(uint8_t data);
 	// SPI Configuration methods
+	void beginTransaction(SPISettings settings);
+	void endTransaction(void);
+	
 	void attachInterrupt();
 	void detachInterrupt();
+	
+	void usingInterrupt(uint8_t interruptNumber);
 
 	void begin();
+	void beginSlave();
 	void end();
 	
 	void setBitOrder(BitOrder order);
 	void setDataMode(uint8_t uc_mode);
-	void setClockDivider(uint8_t uc_div);
+	void setClockDivider(uint16_t uc_div);
 
   private:
@@ -42,4 +115,8 @@
 	uint8_t _uc_pinMosi;
 	uint8_t _uc_pinSCK;
+	uint8_t interruptMode;
+	uint32_t interruptMask;
+	uint8_t interruptSave;
+	uint8_t inTransactionFlag;
 };
 
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestClient/CiaoRestClient.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestClient/CiaoRestClient.ino	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestClient/CiaoRestClient.ino	(revision 224)
@@ -3,13 +3,16 @@
 
 #define CONNECTOR     "rest" 
-#define SERVER_ADDR   "192.168.0.100" // change ip address with your server ip address
+#define SERVER_ADDR   "192.168.1.1" // change ip address with your server ip address
 
-int buttonState = LOW; //this variable tracks the state of the button, low if not pressed, high if pressed
-int ledState = -1; //this variable tracks the state of the LED, negative if off, positive if on
+int buttonState; //this variable tracks the state of the button, low if not pressed, high if pressed
+int ledState = HIGH; //this variable tracks the state of the LED, negative if off, positive if on
 long lastDebounceTime = 0;  // the last time the output pin was toggled
 long debounceDelay = 50;    // the debounce time; increase if the output flickers
+String command = "/arduino/mode/13/output";
+int previous_value = LOW;
 
 void setup() {
   Ciao.begin();
+  Ciao.write(CONNECTOR, SERVER_ADDR, command);
   pinMode(2, INPUT);
   
@@ -20,32 +23,29 @@
   //sample the state of the button - is it pressed or not?
   buttonState = digitalRead(2);
- 
+  
   //filter out any noise by setting a time buffer
-  if ( (millis() - lastDebounceTime) > debounceDelay) {
- 
-    //if the button has been pressed, lets toggle the LED from "off to on" or "on to off"
-    if ( (buttonState == HIGH) && (ledState < 0) ) {
- 
-      CiaoData data = Ciao.write(CONNECTOR, SERVER_ADDR, "/arduino/digital/12/1"); //turn LED on
-      ledState = -ledState; //now the LED is on, we need to change the state
-      lastDebounceTime = millis(); //set the current time
+  if ( (buttonState == HIGH) && (previous_value == LOW) && (millis() - lastDebounceTime) > debounceDelay ) {
+    if (ledState == HIGH){
+      command = "/arduino/digital/13/0";
+      ledState = LOW;
     }
-    else if ( (buttonState == HIGH) && (ledState > 0) ) {
- 
-      CiaoData data = Ciao.write(CONNECTOR, SERVER_ADDR, "/arduino/digital/12/0"); //turn LED off
-      ledState = -ledState; //now the LED is off, we need to change the state
-      lastDebounceTime = millis(); //set the current time
-        
-      if (!data.isEmpty()){
-        Ciao.println( "State: " + String (data.get(1)) );
-        Ciao.println( "Response: " + String (data.get(2)) );
-      }
-      else{ 
-        Ciao.println ("Write Error");
-      }
-              
+    else{
+      command = "/arduino/digital/13/1";
+      ledState = HIGH;
     }
- 
+     
+    lastDebounceTime = millis(); //set the current time
+    CiaoData data = Ciao.write(CONNECTOR, SERVER_ADDR, command);  
+    if (!data.isEmpty()){
+      Ciao.println( "State: " + String (data.get(1)) );
+      Ciao.println( "Response: " + String (data.get(2)) );
+    }
+    else{ 
+      Ciao.println ("Write Error");
+    }
+
   }
  
+  previous_value = buttonState;
+ 
 }
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestServer/CiaoRestServer.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestServer/CiaoRestServer.ino	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/examples/CiaoRestServer/CiaoRestServer.ino	(revision 224)
@@ -1,26 +1,31 @@
 /*
 
- This sketch uses the xmpp connector to receive command for the MCU from a xmpp client.
+ This sketch uses the restserver connector receive rest calls. It allows access to
+ the analog and digital pin of the board via rest calls.
+
+ supported boards: Yun,Tian.
 
  Possible commands to send from the xmpp client:
 
- * "digital/PIN"        -> to read a digital PIN
- * "digital/PIN/VALUE"  -> to write a digital PIN (VALUE: 1/0)
- * "analog/PIN/VALUE"   -> to write in a PWM PIN(VALUE range: 0 - 255);
- * "analog/PIN"         -> to read a analog PIN
- * "servo/PIN/VALUE"	  -> to write angle in a SERVO PIN(VALUE range: 0 - 180);
- * "mode/PIN/VALUE"     -> to set the PIN mode (VALUE: input / output)
- * "ledon"              -> turn on led 13
- * "ledoff"             -> turn off led 13
- * "ciao"               -> random answers in 5 different languages
- 
- NOTE: be sure to activate and configure xmpp connector on Linino OS
-       http://labs.arduino.org/Ciao
-   
+ * "/arduino/digital/PIN"       -> to read a digital PIN
+ * "/arduino/digital/PIN/VALUE" -> to write a digital PIN (VALUE: 1/0)
+ * "/arduino/analog/PIN/VALUE"  -> to write in a PWM PIN(VALUE range: 0 - 255);
+ * "/arduino/analog/PIN"        -> to read a analog PIN
+ * "/arduino/servo/PIN/VALUE"   -> to write angle in a SERVO PIN(VALUE range: 0 - 180);
+ * "/arduino/mode/PIN/VALUE"    -> to set the PIN mode (VALUE: input / output)
+
+ Example:
+ "/arduino/mode/13/output" -> pinMode(13, OUTPUT)
+ "/arduino/digital/13/1"     -> digitalWrite(13, HIGH)
+
+
+ NOTE: be sure to activate and configure restserver connector on Linino OS
+  http://labs.arduino.org/Ciao
+
  created September 2015
  by andrea[at]arduino[dot]org
- 
+
  */
- 
+
 #include <Ciao.h>
 #include <Servo.h>
@@ -35,14 +40,14 @@
 void loop() {
 
-  CiaoData data = Ciao.read("restserver");   
-  if(!data.isEmpty()){  
+  CiaoData data = Ciao.read("restserver");
+  if(!data.isEmpty()){
     String id = data.get(0);
     String sender = data.get(1);
     String message = data.get(2);
-    
+
     message.toUpperCase();
-    
+
     String command[3];
-          
+
     splitString(message,"/",command,3);
     execute(command,id);
@@ -71,7 +76,7 @@
 void servoCommand(String cmd[], String id){
    int pin, value;
-  
+
   pin = (cmd[1]).toInt();
-  
+
   if (cmd[2] != "-1") {
     value = (cmd[2]).toInt();
@@ -85,12 +90,12 @@
   }
   else
-    Ciao.writeResponse("restserver",id,"Invalid command");  
+    Ciao.writeResponse("restserver",id,"Invalid command");
 }
 
 void digitalCommand(String cmd[], String id) {
   int pin, value;
-  
+
   pin = (cmd[1]).toInt();
-  
+
   if (cmd[2] != "-1") {
     value = (cmd[2]).toInt();
@@ -99,5 +104,5 @@
       Ciao.writeResponse("restserver",id,"Pin D"+String(pin)+" ON");
     else if(value == 0)
-      Ciao.writeResponse("restserver",id,"Pin D"+String(pin)+" OFF");   
+      Ciao.writeResponse("restserver",id,"Pin D"+String(pin)+" OFF");
   }
   else if (cmd[2] == "-1") {
@@ -111,5 +116,5 @@
 
   pin = (cmd[1]).toInt();
-  
+
   if (cmd[2] != "-1") {
     value =(cmd[2]).toInt();
@@ -127,5 +132,5 @@
 
   pin = (cmd[1]).toInt();
-  
+
   if (cmd[2] == "INPUT") {
     pinMode(pin, INPUT);
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/Ciao.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/Ciao.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/Ciao.h	(revision 224)
@@ -30,11 +30,8 @@
 
 #include <Arduino.h>
+#include <Stream.h>
 #include "lib/CiaoData.h"
 #if defined(__AVR_ATmega328P__)
-#include "lib/rest.h"
 #include "lib/SC16IS750.h"
-#include "lib/espduino.h"
-#else
-#include <Stream.h>
 #endif
 
@@ -44,5 +41,5 @@
 #define BAUDRATE 250000
 #elif defined(ARDUINO_ARCH_SAMD)
-#define BAUDRATE 115200
+#define BAUDRATE 4000000
 #endif
 
@@ -55,18 +52,10 @@
 		CiaoData parse( String, String);
 		void println(String log){};
-		#if defined(__AVR_ATmega32U4__) 
 		CiaoClass(Stream &_stream);
-		#elif defined(ARDUINO_ARCH_SAMD)
-		CiaoClass(Serial_ stream);
-		#endif
 
 	private:
 		void dropAll();
 		bool started;
-		#if defined(__AVR_ATmega32U4__)
 		Stream &stream;
-		#elif defined(ARDUINO_ARCH_SAMD)
-		Serial_ stream;
-		#endif
 };
 
@@ -80,7 +69,7 @@
 		}
 		#elif defined(ARDUINO_ARCH_SAMD)
-		SerialCiaoClass(Serial_ serial)
-			: CiaoClass(serial){
-			// Empty	
+		SerialCiaoClass(Serial_ &_serial)
+			: CiaoClass(_serial), serial(_serial) {
+			// Empty
 		}
 		#endif
@@ -93,5 +82,5 @@
 		HardwareSerial &serial;
 		#elif defined(ARDUINO_ARCH_SAMD)
-		Serial_ serial;
+		Serial_ &serial;
 		#endif
 };
@@ -103,17 +92,21 @@
 #else
 
-// class CiaoData {
-// 	public:
-		
-// 		char* get(int index){
-// 			return msg_split[index];
-// 		}
-  
-// 	public:
-// 		char* msg_split[3];
-		
-// };
+class ArduinoWifiClass : public WifiData
+{
 
-class CiaoClass {
+	public:
+		void begin();		
+
+		boolean connected();
+		void connect(char* , char*);
+
+		void powerON();
+		void powerOFF();
+
+
+};
+
+class CiaoClass : public WifiData
+{
 	public:
 		void begin();
@@ -124,10 +117,10 @@
 		CiaoData write( char*, char*, String );            // ârestâ, âhostnameâ, âStringoneâ,		
 		CiaoData write( char*, char*, String, char*);      // ârestâ, âhostnameâ, âStringoneâ, âmethodâ
-		
-		void print(String str);
-		void println(String str);
 	
 };
+
+
 extern CiaoClass Ciao;
+extern ArduinoWifiClass Wifi;
 
 #endif
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/Ciao.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/Ciao.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/Ciao.cpp	(revision 224)
@@ -24,18 +24,13 @@
 */
 
-#include "Ciao.h"
 
 #if defined(__AVR_ATmega32U4__) || defined(ARDUINO_ARCH_SAMD)
 
-#if defined(__AVR_ATmega32U4__)
+#include "Ciao.h"
+
 CiaoClass::CiaoClass(Stream &_stream) :
 	stream(_stream), started(false) {
   // Empty
 }
-#elif defined(ARDUINO_ARCH_SAMD)
-CiaoClass::CiaoClass(Serial_ stream){
-  // Empty
-}
-#endif
 
 void CiaoClass::begin() {
@@ -60,8 +55,6 @@
     }
 	do{ 
-		#if defined(__AVR_ATmega32U4__)
 		stream.print(F("run-ciao\n"));				//start bridge python
 		stream.readStringUntil(END_TX_CHAR);
-		#endif
 		delay(3000);
 		stream.println("ciao;r;status");				//check if bridge python is running
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.cpp	(revision 224)
@@ -27,13 +27,7 @@
 #define WIRE Wire
 
-
-WifiData::WifiData(uint8_t prtcl, uint8_t addr_sspin)
-{
-    protocol = prtcl;
-    if ( protocol == SC16IS750_PROTOCOL_I2C ) {
-        device_address_sspin = (addr_sspin>>1);
-    } else {
-        device_address_sspin = addr_sspin;
-    }
+WifiData::WifiData()
+{
+    device_address_sspin = (SC16IS750_ADDRESS_AA >> 1);
     peek_flag = 0;
 }
@@ -41,7 +35,6 @@
 void WifiData::begin(uint32_t baud)
 {
-    //Serial.println("1111111111111111");
+
     if ( protocol == SC16IS750_PROTOCOL_I2C) {
-    //Serial.println("22222222222222");
         WIRE.begin();
     } 
Index: rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/Ciao/src/lib/SC16IS750.h	(revision 224)
@@ -104,10 +104,11 @@
 #define     SC16IS750_PROTOCOL_I2C  (0)
 #define     SC16IS750_PROTOCOL_I2C  (0)
-#define     END     "<!--~-->"
+#define     DELIMITER     "<!--~-->"
+#define     EOL           '\0'
 
 class WifiData : public Stream
 { 
     public:
-        WifiData(uint8_t prtcl = SC16IS750_PROTOCOL_I2C, uint8_t addr = SC16IS750_ADDRESS_AD);
+	WifiData();
         void begin(uint32_t baud);                               
         int read();
